#encoding: UTF-8
=begin
/***************************************************************************
 *   ©2011-2016 Michael Uplawski <michael.uplawski@uplawski.eu>  	   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
=end

require 'gtk3'
require_relative '../cremefraiche'
require_relative '../translating'
require_relative '../file_checking'
require_relative '../license.rb'
require_relative '../logging.rb'

GD = File::expand_path(File::dirname(__FILE__) ) + File::Separator if !defined?(GD)

class AboutDialog
	@@License_File = GD.dup << '../doc/license.txt'
	include Translating
	include Logging
	def initialize( options = {})
		init_logger($CONF.log_file ? $CONF.log_file : STDOUT, $CONF.log_level ? $CONF.log_level : Logger::UNKNOWN)
		prog_info = CremeFraiche::prog_info

		@adialog = Gtk::AboutDialog.new
		@adialog.name = prog_info[:app_name]
		@adialog.title = prog_info[:app_name]
		@adialog.set_program_name prog_info[:app_name]
		@adialog.version = prog_info[:version]
		@adialog.copyright = "© #{prog_info[:years]} #{prog_info[:author]} #{prog_info[:author_mail]}"
		@adialog.website = "#{prog_info[:web_page]}"
		@adialog.website = trl("Project Homepage")
		comment = trl('running with Ruby') << ' ' << RUBY_VERSION << ' (' << RUBY_RELEASE_DATE << ') ' << RUBY_PLATFORM.dup
	       	comment << "\n\n" << trl('Current system') << ': ' << prog_info[:cur_system]
		@adialog.comments = comment

		@adialog.logo = Gdk::Pixbuf.new(GD + "icon.xpm")
		@adialog.signal_connect('response') do |dlg, resp|
			@log.debug("response %i emitted" %resp) if @log
			@adialog.destroy if(Gtk::ResponseType::CANCEL == resp) 
		end  
		if(options && options.keys.include?(:on_destroy))
			@adialog.signal_connect('destroy') {options[:on_destroy].call() }
		end
		@adialog.license = LICENSE_TEXT
		@adialog.show
	end
end

