#encoding: UTF-8
=begin
/***************************************************************************
 *   ©2011-2016 Michael Uplawski <michael.uplawski@uplawski.eu>  	   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
=end

require_relative '../logging'
require 'gtk3'
require_relative '../translating'

=begin
  Meant to be used as label for push-buttons,
  objects of this class combine a text-value
  with a user-provided icon.
=end
class ButtonLabel < Gtk::Box
	include Logging
	def initialize(text, imagefile = nil)
		init_logger($CONF.log_file ? $CONF.log_file : STDOUT, $CONF.log_level ? $CONF.log_level : Logger::UNKNOWN)
		super(:horizontal, 5)
		set_border_width(0)
		pack_start(Gtk::Image.new(:file => imagefile)) if imagefile
		@mlabel = Gtk::Label.new( text, :mnemonic => true)
		@mlabel.markup_with_mnemonic=text
		# @log.debug(@mlabel.mnemonic_keyval)
		pack_start(@mlabel) 
	end

	def mnemonic_widget=(wd)
		@mlabel.mnemonic_widget=(wd)
	end

end
