#encoding: UTF-8
=begin
/***************************************************************************
 *   ©2016-2016 Michael Uplawski <michael.uplawski@uplawski.eu>            *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         * 
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
=end

# An object of this type represents the value of a configuration-option in case
# that it needs to be translated for display in the GUI, but not for the
# persistent configuration.
#
# Not every value needs to be encapsulated in a ConfValue object. Test, if there
# is a translation to read with value.respond_to?(:display_value). In case that a 
# translation exists, persist obj.value. Otherwise show and persist the value
# as is. 
# Examples: 'A4', 'A5', 'letter' will not be translated, but used and displayed
# in the same way, as 'A4', 'A5' or 'letter'. You do not need a ConfValue in that 
# case.
#
# 'landscape' and 'portrait' in contrast may be displayed as 'paysage' and
# 'portrait' in French, 'Hochformat' and 'Querformat' in the German locale, while
# the configuration file will only contain 'landscape' or 'portrait'.
#
# See conf_option.rb for actual uses.

require_relative '../translating'

class ConfValue
  include Translating
  def initialize(label, value)
    @label = label
    @value = value
    @value ||= ''
    if(value.respond_to?(:to_ary) )
      @display_value = @value.map{|v| trl(v) }
    else
      @display_value = trl(value.to_s, false)
    end
  end
  def to_s
    self.class.name << ': value = ' << @value.to_s << ', display_value = ' << @display_value.to_s
  end

  attr_accessor :value
  attr_reader :display_value

end

# EOF

